diff --git a/django/contrib/comments/templates/comments/400-debug.html b/django/contrib/comments/templates/comments/400-debug.html
index 3c4532b..9e33f46 100644
--- a/django/contrib/comments/templates/comments/400-debug.html
+++ b/django/contrib/comments/templates/comments/400-debug.html
@@ -1,5 +1,6 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
-<html lang="en">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
+"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
 <head>
   <meta http-equiv="content-type" content="text/html; charset=utf-8" />
   <title>Comment post not allowed (400)</title>
diff --git a/django/contrib/comments/templates/comments/approve.html b/django/contrib/comments/templates/comments/approve.html
index a4306a6..aa465fc 100644
--- a/django/contrib/comments/templates/comments/approve.html
+++ b/django/contrib/comments/templates/comments/approve.html
@@ -7,7 +7,7 @@
   <h1>{% trans "Really make this comment public?" %}</h1>
   <blockquote>{{ comment|linebreaks }}</blockquote>
   <form action="." method="post">
-    {% if next %}<input type="hidden" name="next" value="{{ next }}" id="next" />{% endif %}
+    {% if next %}<p><input type="hidden" name="next" value="{{ next }}" id="next" /></p>{% endif %}
     <p class="submit">
       <input type="submit" name="submit" value="{% trans "Approve" %}" /> or <a href="{{ comment.get_absolute_url }}">cancel</a>
     </p>
diff --git a/django/contrib/comments/templates/comments/base.html b/django/contrib/comments/templates/comments/base.html
index 36fc66f..baf1f40 100644
--- a/django/contrib/comments/templates/comments/base.html
+++ b/django/contrib/comments/templates/comments/base.html
@@ -1,5 +1,6 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
-<html lang="en">
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
+"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
 <head>
   <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
   <title>{% block title %}{% endblock %}</title>
diff --git a/django/contrib/comments/templates/comments/delete.html b/django/contrib/comments/templates/comments/delete.html
index 7d73eac..51fb485 100644
--- a/django/contrib/comments/templates/comments/delete.html
+++ b/django/contrib/comments/templates/comments/delete.html
@@ -7,7 +7,7 @@
 <h1>{% trans "Really remove this comment?" %}</h1>
   <blockquote>{{ comment|linebreaks }}</blockquote>
   <form action="." method="post">
-    {% if next %}<input type="hidden" name="next" value="{{ next }}" id="next" />{% endif %}
+    {% if next %}<p><input type="hidden" name="next" value="{{ next }}" id="next" /></p>{% endif %}
     <p class="submit">
     <input type="submit" name="submit" value="{% trans "Remove" %}" /> or <a href="{{ comment.get_absolute_url }}">cancel</a>
     </p>
diff --git a/django/contrib/comments/templates/comments/flag.html b/django/contrib/comments/templates/comments/flag.html
index 08dbe0b..5761f90 100644
--- a/django/contrib/comments/templates/comments/flag.html
+++ b/django/contrib/comments/templates/comments/flag.html
@@ -7,7 +7,7 @@
 <h1>{% trans "Really flag this comment?" %}</h1>
   <blockquote>{{ comment|linebreaks }}</blockquote>
   <form action="." method="post">
-    {% if next %}<input type="hidden" name="next" value="{{ next }}" id="next" />{% endif %}
+    {% if next %}<p><input type="hidden" name="next" value="{{ next }}" id="next" /></p>{% endif %}
     <p class="submit">
     <input type="submit" name="submit" value="{% trans "Flag" %}" /> or <a href="{{ comment.get_absolute_url }}">cancel</a>
     </p>
diff --git a/django/contrib/comments/templates/comments/form.html b/django/contrib/comments/templates/comments/form.html
index d8e2483..b60e6c8 100644
--- a/django/contrib/comments/templates/comments/form.html
+++ b/django/contrib/comments/templates/comments/form.html
@@ -3,7 +3,7 @@
   {% if next %}<input type="hidden" name="next" value="{{ next }}" />{% endif %}
   {% for field in form %}
     {% if field.is_hidden %}
-      {{ field }}
+      <p>{{ field }}</p>
     {% else %}
       {% if field.errors %}{{ field.errors }}{% endif %}
       <p
diff --git a/django/contrib/comments/templates/comments/preview.html b/django/contrib/comments/templates/comments/preview.html
index d388457..0822faa 100644
--- a/django/contrib/comments/templates/comments/preview.html
+++ b/django/contrib/comments/templates/comments/preview.html
@@ -18,7 +18,7 @@
     {% endif %}
     {% for field in form %}
       {% if field.is_hidden %}
-        {{ field }}
+        <p>{{ field }}</p>
       {% else %}
         {% if field.errors %}{{ field.errors }}{% endif %}
         <p