diff --git a/django/conf/global_settings.py b/django/conf/global_settings.py
--- a/django/conf/global_settings.py
+++ b/django/conf/global_settings.py
@@ -398,7 +398,7 @@
 
 # Do you want to manage transactions manually?
 # Hint: you really don't!
-TRANSACTIONS_MANAGED = False
+DISABLE_TRANSACTION_MANAGEMENT = False
 
 # The User-Agent string to use when checking for URL validity through the
 # isExistingURL validator.
diff --git a/django/db/backends/__init__.py b/django/db/backends/__init__.py
--- a/django/db/backends/__init__.py
+++ b/django/db/backends/__init__.py
@@ -92,7 +92,15 @@
         if self.transaction_state:
             self.transaction_state.append(self.transaction_state[-1])
         else:
-            self.transaction_state.append(settings.TRANSACTIONS_MANAGED)
+            if hasattr(settings, 'TRANSACTIONS_MANAGED'):
+                warnings.warn(
+                    'The `TRANSACTIONS_MANAGED` setting is deprecated. '
+                    'Please update your code to use DISABLE_TRANSACTION_MANAGEMENT.',
+                    PendingDeprecationWarning
+                )
+                self.transaction_state.append(settings.TRANSACTIONS_MANAGED)
+            else:
+                self.transaction_state.append(settings.DISABLE_TRANSACTION_MANAGEMENT)
 
         if self._dirty is None:
             self._dirty = False
@@ -156,7 +164,14 @@
         """
         if self.transaction_state:
             return self.transaction_state[-1]
-        return settings.TRANSACTIONS_MANAGED
+        if hasattr(settings, 'TRANSACTIONS_MANAGED'):
+            warnings.warn(
+                'The `TRANSACTIONS_MANAGED` setting is deprecated. '
+                'Please update your code to use DISABLE_TRANSACTION_MANAGEMENT.',
+                PendingDeprecationWarning
+            )
+            return settings.TRANSACTIONS_MANAGED
+        return settings.DISABLE_TRANSACTION_MANAGEMENT
 
     def managed(self, flag=True):
         """
diff --git a/docs/internals/deprecation.txt b/docs/internals/deprecation.txt
--- a/docs/internals/deprecation.txt
+++ b/docs/internals/deprecation.txt
@@ -220,6 +220,10 @@
           was deprecated since Django 1.4 and will be removed in favor of the
           generic static files handling.
 
+	* The :setting:`TRANSACTIONS_MANAGED` setting has been deprecated
+	  since Django 1.4 and will be ignored. It has been replaced by
+          :setting:`DISABLE_TRANSACTION_MANAGEMENT`.
+
     * 2.0
         * ``django.views.defaults.shortcut()``. This function has been moved
           to ``django.contrib.contenttypes.views.shortcut()`` as part of the
diff --git a/docs/ref/settings.txt b/docs/ref/settings.txt
--- a/docs/ref/settings.txt
+++ b/docs/ref/settings.txt
@@ -809,7 +809,21 @@
 Default tablespace to use for models that don't specify one, if the
 backend supports it.
 
-.. setting:: DISALLOWED_USER_AGENTS
+.. setting:: DISABLE_TRANSACTION_MANAGEMENT
+
+DISABLE_TRANSACTION_MANAGEMENT
+------------------------------
+
+.. versionadded:: 1.4
+
+Default: ``False``
+
+This is a setting whose value is seldomly changed.
+
+If you set it to ``True``, Django won't provide any automatic transaction
+management.  See :ref:`deactivating-db-transaction-management` for more details.
+
+Before Django 1.4 the name of this setting was ``TRANSACTIONS_MANAGED``.
 
 DISALLOWED_USER_AGENTS
 ----------------------
@@ -2148,3 +2162,11 @@
 .. deprecated:: 1.2
    This setting has been replaced by :setting:`TEST_NAME` in
    :setting:`DATABASES`.
+
+.. setting:: TRANSACTIONS_MANAGED
+
+TRANSACTIONS_MANAGED
+--------------------
+
+.. deprecated:: 1.4
+   This setting has been replaced by :setting:`DISABLE_TRANSACTION_MANAGEMENT`.
diff --git a/docs/releases/1.4.txt b/docs/releases/1.4.txt
--- a/docs/releases/1.4.txt
+++ b/docs/releases/1.4.txt
@@ -489,3 +489,10 @@
 
 The existence of any ``'filters'`` key under the ``'mail_admins'`` handler will
 disable this backward-compatibility shim and deprecation warning.
+
+``TRANSACTIONS_MANAGED`` setting
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+This setting has been replaced by the :setting:`DISABLE_TRANSACTION_MANAGEMENT`
+setting. Both settings have the same default values and semantics.
+
diff --git a/docs/topics/db/transactions.txt b/docs/topics/db/transactions.txt
--- a/docs/topics/db/transactions.txt
+++ b/docs/topics/db/transactions.txt
@@ -204,11 +204,14 @@
 if your transaction only reads from the database, the transaction must
 be committed or rolled back before you complete a request.
 
+.. _deactivating-db-transaction-management:
+
 How to globally deactivate transaction management
 =================================================
 
 Control freaks can totally disable all transaction management by setting
-``DISABLE_TRANSACTION_MANAGEMENT`` to ``True`` in the Django settings file.
+:setting:`DISABLE_TRANSACTION_MANAGEMENT` to ``True`` in the Django settings
+file.
 
 If you do this, Django won't provide any automatic transaction management
 whatsoever. Middleware will no longer implicitly commit transactions, and